import tkinter as tk
from tkinter import *
from tkinter import ttk

class MainWin(tk.Tk):
    adsrv = ['A', 'D', 'S', 'R','V']
    freqs = ['1','2','3','4','5']
    mixer = ['1','2','3','4','5']
    lfo1 = ['lfo1']
    def __init__(self):
        super().__init__()
        self.index = 0
        self.populate()

    def populate(self):
        self.title(' SINTHETIZER ')
        st_pnl = tk.LabelFrame(self, text=' ENVELOPE (db. X 1000) ', fg='white', bg='black')
        st_pnl.pack(padx=5, pady=5)
        st_pnl.grid(row=0, column=0, sticky='se')
        self.v_scales = []
        self.h_scales = []
        for i in range(len(self.adsrv)):
            cnv = tk.Label(st_pnl, text=self.adsrv[i], bg='black', fg='white', pady=10, padx=10, font=10)
            cnv.grid(row=0, column=i, padx=12, pady=50, sticky='ne')
            cnv = tk.Canvas(st_pnl, width=12, height=50)
            sc = tk.Scale(st_pnl, from_=25, to=0, showvalue=True,  length=200, tickinterval=1, bg='black', fg='white', orient=tk.VERTICAL)
            sc.set(0)
            sc.bind("<ButtonRelease>", self.on_struments)
            sc.grid(row=2, column=i, padx=10, pady=10, sticky='ne')
            st_pnl.grid_columnconfigure(i, weight=1)
            self.v_scales.append(sc)
            self.h_scales.append(sc)   
        st_pnl.grid_rowconfigure(1, weight=1)
        fr_pnl = tk.LabelFrame(self, text=' Frequency (Hz x 10)', fg="white", bg="black")
        fr_pnl.grid(row=0, column=1, sticky='ew')
        for i in range(len(self.freqs)):
            lbl = tk.Label(fr_pnl, text=self.freqs[i], fg='white', bg="black")
            lbl.grid(row=0, column=i, padx=5, pady=50, sticky='ne')
            scvco = tk.Scale(fr_pnl, from_=420, to=0, showvalue=True, length=200, tickinterval=1,background='black', fg='white', orient=tk.VERTICAL)
            scvco.set(0)
            scvco.bind("<ButtonRelease>", self.on_frequences)
            scvco.grid(row=1, column=i, padx=10, pady=10, sticky='ne')
            self.h_scales.append(scvco)
        fr_pnl.grid_columnconfigure(1, weight=1)
        val_pnl = tk.LabelFrame(self, text='')
        #val_pnl.grid(row=2, column=0, columnspan=2, sticky='ew')
        lbl = tk.Label(val_pnl, text='', font='bold')
        #crea mixer
        for i in range(len(self.freqs)):
            lbl = tk.Label(val_pnl, text=self.freqs[i], font='bold')
            lbl.grid(row=i, column=0, padx=10, pady=10)
        self.lst_val = []
        row = 1
        for s in self.adsrv:
            lbl = tk.Label(val_pnl, text=s, fg='white', bg='black')
            lbl.grid(row=2, column=0, padx=10, pady=10)
            l_row = []
            #lbl = tk.Label(val_pnl, text='', width=4, relief='sunken')
            #lbl.grid(row=row, column=1, padx=10, pady=10)
            l_row.append(lbl)
            for i in range(len(self.freqs)):
                lbl = tk.Label(val_pnl, text='', width=4, relief='sunken')
                lbl.grid(row=0, column=i, padx=10, pady=10)
                l_row.append(lbl)
            self.lst_val.append(l_row)
        fr_pnl = tk.LabelFrame(self, text=' Mixer (ohms x 10)', fg="white", bg="black")
        fr_pnl.grid(row=2, column=1, sticky='ew')
        for i in range(len(self.mixer)):
            lbl = tk.Label(fr_pnl, text=self.mixer[i], fg="white", bg="black")
            lbl.grid(row=1, column=i, padx=10, pady=10, sticky='se')
            cnv.grid(row=2, column=i, padx=10, pady=10, sticky='se')
            scmixer = tk.Scale(fr_pnl, from_=2000, to=0, showvalue=True, length=200, tickinterval=1,background='black', fg='white', orient=tk.VERTICAL)
            scmixer.set(330)
            scmixer.bind("<ButtonRelease>", self.on_frequences)
            scmixer.grid(row=1, column=i, padx=10, pady=10, sticky='se')
            self.h_scales.append(scmixer)
            for i in range(len(self.mixer)):
                lbl = tk.Label(val_pnl, text='', width=4, relief='sunken', fg="white", bg="black")
                lbl.grid(row=1, column=i, padx=10, pady=10)
                l_row.append(lbl)
                self.lst_val.append(l_row)
        #crea LFO1 per FM
        fr = tk.LabelFrame(self, text='LFO1 for FM (Hz)', fg="white", bg="black")
        fr.grid(row=2, column=0, sticky='se')
        sclfo1= tk.Scale(fr, from_=50, to=0, showvalue=True, length=200, tickinterval=1,background='black', fg='white', orient=tk.VERTICAL)
        sclfo1.set(0)
        sclfo1.bind("<ButtonRelease>", self.on_frequences)
        sclfo1.grid(row=2, column=0, padx=10, pady=10, sticky='se')
        self.h_scales.append(sclfo1)
        for i in range(len(self.freqs)):
            val_pnl.grid_columnconfigure(1, weight=i, uniform='a')

        self.grid_columnconfigure(1, weight=1)

    def on_struments(self, evt):
        w = evt.widget
        try:
            index = self.v_scales.index(w)
            value = w.get()
            print(value)
        except ValueError:
            return
        self.index = index
        self.lst_val[self.index][0].configure(text=value)
        
        
    def on_frequences(self, evt):
        w = evt.widget
        try:
            index = self.h_scales.index(w)
            value = w.get()
            print(value)
        except ValueError:
            return
        self.lst_val[self.index][index+1].configure(text=value)


if __name__ == '__main__':
    #crea finestra
    app = MainWin()
    app.configure(background='black')
    app.geometry("1000x1000+0+0")
    app.resizable(False,False)
    app.configure(bg="black")
    app.mainloop()

    #crea menu "File"
    menubar1 = tk.Menu(app, background = "black", fg="white") 
    filemenu1 = tk.Menu(menubar)
    filemenu1.add_command(label="Open")
    filemenu1.add_command(label="Save")
    menubar.add_cascade(label="LFO1 function", menu=filemenu1)
    app.config(menu=menubar1)
    app.config(menu=menubar)
    app.mainloop()
    
    
   

    

